*--------------------------------------------------------------------*
*                           PARAMETERS                               *
*--------------------------------------------------------------------*
WorkArea=$70000

*--------------------------------------------------------------------*
*                        START OF BOOTBLOCK                          *
*--------------------------------------------------------------------*
	dc.b	"DOS",0
	dc.l	0,$370

*--------------------------------------------------------------------*
*                        COPPERLISTROUTINE                           *
*--------------------------------------------------------------------*
BootStrap
	lea	GfxName(pc),a1
	jsr	-408(a6)
	move.l	d0,a6
	lea	WorkArea,a4
	move.l	a4,a1
.1	clr.l	(a1)+
	move.w	a1,d0
	bpl.s	.1
	lea	$3800(a4),a1
	lea	BootStrap(pc),a2
	moveq	#$2a,d0
.2	move.b	d0,(a1)+
	move.b	d1,(a1)+
	add.b	(a2)+,d1
	addq.b	#1,d0
	move.b	d0,(a1)+
	clr.b	(a1)+
.3	addq.w	#1,d2
	and.w	#$03,d2
	beq.s	.3
	move.w	d2,(a1)+
	clr.w	(a1)+
	addq.b	#1,d0
	bne.s	.2

	lea	CopperList(pc),a1
	lea	$4000(a4),a2
	lea	$dff006,a5
	move.w	#$83a0,$90(a5)
	move.l  $32(a6),-(a7)
	move.l  a2,$32(a6)
.4	move.w	(a1)+,(a2)+
	bpl.s	.4
MakeBars
	movem.w	(a1)+,d0-d3
	move.l	#$01a20ccc,(a2)+
	bsr.s	.WriteColor
	move.w	#$01a2,(a2)+
	move.w	d1,(a2)+
	bsr.s	.DownColor
	sub.w	d2,d1
	moveq	#$04,d4
.1	bsr.s	.DownTextColor
	dbf	d4,.1
	bsr.s	.DownColor
	bsr.s	.DownColor
	clr.w	d1
	bsr.s	.WriteColor
	bcc.s	MakeBars
	subq.l	#2,(a2)
	bra.s	Init
.DownColor
	sub.w	d2,d1
.WriteColor
	move.w	d0,(a2)+
	move.l	#$fffe0180,(a2)+
 	move.w	d1,(a2)+
	add.w	#$0100,d0
	rts
.DownTextColor
	bsr.s	.WriteColor
	move.w	#$0182,(a2)+
	move.w	d3,(a2)+
	move.w	#$0186,(a2)+
	move.w	d3,(a2)+
	sub.w	#$0111,d3
	add.w	#$0200,d0
	rts

*--------------------------------------------------------------------*
*                          INITIATIONROUTINE                         *
*--------------------------------------------------------------------*
Init
	lea     -$200(a4),a0
	move.l	a0,a2
	moveq	#01,d0
	move.w  #768,d1
	move.w  #256,d2
	jsr     -390(a6)
	move.l  a4,8(a2)
	lea     -$100(a4),a1
	move.l	a1,a3
	jsr     -198(a6)
	move.l  a2,4(a3)
	moveq	#01,d0
	jsr	-342(a6)

	lea	BarText(pc),a2
	clr.w	d3
Print	moveq	#52,d2
	move.b	(a2)+,d3
	beq.s	Skroll
	moveq	#31,d4
	bsr.s	Write
	bra.s	Print

Subr	clr.l	$fe(a5)
	subq.w	#1,d7
	bne.s	ScrollBar

*--------------------------------------------------------------------*
*                          SCROLLROUTINE                             *
*--------------------------------------------------------------------*
	move.b	(a2),d0
	bne.s	Good
Skroll	lea	ScrollText(pc),a2		; Restart Text
Good	move.w	#374,d2
	moveq	#$ec/2+1,d3
	moveq	#$01,d4
	bsr.s	Write
	moveq	#$03,d7

*--------------------------------------------------------------------*
*                          SCROLLROUTINE                             *
*--------------------------------------------------------------------*
ScrollBar
	move.l	a3,a1		; Scroll Screen
	moveq	#03,d0
	moveq	#00,d1
	moveq	#00,d2
	moveq	#$ec/2-6,d3
	move.w	#768,d4
	moveq	#$ec/2+2,d5
	jsr	-396(a6)

*--------------------------------------------------------------------*
*                       STAR MOVEMENT ROUTINE                        *
*--------------------------------------------------------------------*
Wait	cmp.b	#$ff,(a5)
	bne.s	Wait
	lea	$3901(a3),a1
	moveq	#$2a,d0
Nully	move.b	4(a1),d1
	add.b	d1,(a1)
	addq.l	#8,a1
	addq.b	#2,d0
	bne.s	Nully

*--------------------------------------------------------------------*
*                     KEY SELECTION DETECTION                        *
*--------------------------------------------------------------------*
	move.b	$bfec01,d2
	not.b	d2
	lsr.w	#1,d2
	sub.b	#$50,d2
	bcs.s	Subr
	cmp.b	#$05,d2		;cmp.b #(Highest funktion key number)
	bcc.s	Subr
	move.w	d2,$0080.W

*--------------------------------------------------------------------*
*                          ENDINGROUTINE                             *
*--------------------------------------------------------------------*
	move.l  (a7)+,$32(a6)
	move.l	$4.w,a6
	lea	DosName(pc),a1
	jsr	-96(a6)
 	move.l	d0,a0
 	move.l	22(a0),a0
	jmp	(a0)

*--------------------------------------------------------------------*
*                        PRINTSTRINGROUTINE                          *
*--------------------------------------------------------------------*
Write
	bsr.s	.1
	add.w	#384,d2
	sub.l	d4,a2
.1	move.l	a3,a1
	move.l	d2,d0
	move.l	d3,d1
	jsr	-240(a6)
	move.l	a2,a0
	move.l	d4,d0
	add.l	d4,a2
	jmp	-60(a6)

*--------------------------------------------------------------------*
*                         COPPERLIST                                 *
******* dc.w    copperinstructions,$0184,$8000 ***********************
*--------------------------------------------------------------------*
CopperList
	dc.w	$0100,$2200,$0102,$0010
	dc.w	$0092,$0020,$0094,$00d8
	dc.w	$008e,$2c21,$0090,$00e1
	dc.w	$00e0,$0007,$00e2,$0600
	dc.w	$00e4,$0007,$00e6,$05d0
	dc.w	$0120,$0007,$0122,$3800
	dc.w	$0180,$0000,$0184,$8000

*--------------------------------------------------------------------*
*                            BARDATA                                 *
******* dc.w    linenr,barcolor,shading,textcolor ********************
*--------------------------------------------------------------------*
BarData
	dc.w	$3401,$00f9,$0021,$0ca8
	dc.w	$4c01,$00d7,$0021,$0b97
	dc.w	$7001,$0b50,$0210,$0a86
	dc.w	$8601,$0c60,$0210,$0b97
	dc.w	$9c01,$0d70,$0210,$0ca8
	dc.w	$b201,$0c60,$0210,$0b97
	dc.w	$c801,$0b50,$0210,$0a86
	dc.w	$ec01,$057a,$0012,$0a86

*--------------------------------------------------------------------*
*                          SYSTEMSTRINGS                             *
*--------------------------------------------------------------------*
DosName	dc.b	"dos.library",0
GfxName	dc.b	"graphics.library",0

*--------------------------------------------------------------------*
*                         SELECTIONTEXT                              *
******* dc.b 	linenr/2+1,31 letters of text ************************
*--------------------------------------------------------------------*
BarText	dc.b	$34/2+1,"DEFJAM and CCS Proudly Present:"
	dc.b	$4c/2+1,"       Compact Disk No 9       "
	dc.b	$70/2+1,"[F1] Beyond Ice Palace  (087 K)"
	dc.b	$86/2+1,"[F2] Carrier Command    (147 K)"
	dc.b	$9c/2+1,"[F3] Starglider II      (217 K)"
	dc.b	$b2/2+1,"[F4] Thundercats        (182 K)"
	dc.b	$c8/2+1,"[F5] Vixen              (168 K)"
	dc.b	0

*--------------------------------------------------------------------*
*                           SCROLLTEXT                               *
******* dc.b 	letters of scrolltext,0 ******************************
*--------------------------------------------------------------------*
ScrollText
	dc.b	"Yeeaah, another compact disk from CCS."
	dc.b	" This intro was made by PHS of CCS in 1024 bytes. "
	dc.b	0

