	Section	Program,Code

	include	exec/exec.i
	include	exec/exec_lib.i
	include	dos/dos.i
	include	dos/dos_lib.i
	include	intuition/intuition.i
	include	intuition/intuition_lib.i
	include	devices/trackdisk.i

	bsr	OpenLibraries
	bsr	AllocMemory
	bsr	MakeIOStdReq
	bsr	MakeReplyPort
	bsr	OpenTrackDisk
	move.l	#$80000,a0
	move.l	#$0370,d0
	move.l	#$2c00,d1
	bsr	ReadBlocks
	bsr	CloseTrackDisk
	bsr	FreeMemory
	bsr	CloseLibraries
	moveq	#$00,d0
	rts


OpenLibraries
	movem.l	a1/a6,-(a7)
	lea	DOS_Name(pc),a1
	CALLEXEC OldOpenLibrary
	move.l	d0,_DOSBase
	lea	INTUITION_Name(pc),a1
	CALLEXEC OldOpenLibrary
	move.l	d0,_IntuitionBase
	CALLDOS	Output
	move.l	d0,Output
	movem.l	(a7)+,a1/a6
	rts

CloseLibraries
	movem.l	a1/a6,-(a7)
	move.l	_DOSBase,a1
	CALLEXEC CloseLibrary
	move.l	_IntuitionBase,a1
	CALLEXEC CloseLibrary
	movem.l	(a7)+,a1/a6
	rts

AllocMemory
	movem.l	d1/a6,-(a7)
	move.l	#$00000030,d0
	move.l	#$00010000,d1		;Clear
	CALLEXEC AllocMem
	move.l	d0,IOStdReq
	move.l	#$00000022,d0
	move.l	#$00010000,d1		;Clear
	CALLEXEC AllocMem
	move.l	d0,ReplyPort
	move.l	#$00000200,d0
	move.l	#$00010002,d1		;Chip|Clear
	CALLEXEC AllocMem
	move.l	d0,DiskBuff
	movem.l	(a7)+,d1/a6
	rts

FreeMemory
	movem.l	a1/a6,-(a7)
	move.l	IOStdReq,a1
	move.l	#$00000030,d0
	CALLEXEC FreeMem
	move.l	ReplyPort,a1
	move.l	#$00000022,d0
	CALLEXEC FreeMem
	move.l	DiskBuff,a1
	move.l	#$00000200,d0
	CALLEXEC FreeMem
	movem.l	(a7)+,a1/a6
	rts

MakeIOStdReq
	movem.l	a1-a2,-(a7)
	move.l	IOStdReq,a2
	move.b	#NT_MESSAGE,LN_TYPE(a2)
	lea	Node_Name(pc),a1
	move.l	a1,LN_NAME(a2)
	move.l	ReplyPort,MN_REPLYPORT(a2)
	movem.l	(a7)+,a1-a2
	rts

MakeReplyPort
	movem.l	a1-a2/a6,-(a7)
	move.l	ReplyPort,a2
        move.b	#NT_MSGPORT,LN_TYPE(a2)
	lea	Node_Name(pc),a1
	move.l	a1,LN_NAME(a2)
	suba.l	a1,a1
	CALLEXEC FindTask
	move.l	d0,MP_SIGTASK(a2)
	moveq	#$ffffffff,d0
	CALLEXEC AllocSignal
	move.b	d0,MP_SIGBIT(a2)
	movem.l	(a7)+,a1-a2/a6
	rts

OpenTrackDisk
	movem.l	d1/a1/a6,-(a7)
	lea	TD_Name(pc),a0		;devName
	moveq	#$00,d0			;unit
	move.l	IOStdReq,a1		;ioRequest
	moveq	#$01,d1			;flags
	CALLEXEC OpenDevice
	movem.l	(a7)+,d1/a1/a6
	rts

CloseTrackDisk
	movem.l	a1/a6,-(a7)
	moveq	#$00,d0			;unit
	move.l	IOStdReq,a1		;ioRequest
	move.w	#TD_MOTOR,IO_COMMAND(a1)
	clr.l	IO_LENGTH(a1)
	CALLEXEC DoIO
	move.l	IOStdReq,a1		;ioRequest
	CALLEXEC CloseDevice
	move.l	ReplyPort,a1		;MsgPort
	moveq	#$00,d0
	move.b	MP_SIGBIT(a1),d0
	CALLEXEC FreeSignal
	movem.l	(a7)+,a1/a6
	rts

ReadBlocks			;A0=Buffer,D0=Blocknr,D1=Length
	movem.l	a1/a6,-(a7)
	move.l	IOStdReq,a1		;ioRequest
	move.w	#CMD_READ,IO_COMMAND(a1)
	move.b	#IOB_QUICK,IO_FLAGS(a1)
	mulu	#$0200,d0
	add.l	#$01ff,d1
	divu	#$0200,d1
	mulu	#$0200,d1
	move.l	d1,IO_LENGTH(a1)
	move.l	a0,IO_DATA(a1)
	move.l	d0,IO_OFFSET(a1)
	CALLEXEC DoIO
	movem.l	(a7)+,a1/a6
	rts

Node_Name
	dc.b	"Specialos",0
TD_Name
	TD_NAME
DOS_Name
	DOSNAME
INTUITION_Name:
	INTNAME
	even
_DOSBase
	dc.l	0
_IntuitionBase
	dc.l	0
Output
	dc.l	0
DiskBuff
	dc.l	0
IOStdReq
	dc.l	0
ReplyPort
	dc.l	0


