	Section	Startup,Code
	Include	exec/execbase.i
	Include	exec/exec_lib.i
	Include	graphics/gfxbase.i
	Include	graphics/graphics_lib.i
	Include	resources/cia.i
	Include	resources/cia_lib.i

Main
	bsr	OpenLibraries
	bsr	AllocateMemory
	bsr	CopyData
	bsr	InitIntStruct
	bsr	AddInterrupt
	and.b	#$f7,$bfdf00
	or.b	#$11,$bfdf00
	bsr	TellSystem
	moveq	#$00,d0
	rts

OpenLibraries
	lea	GfxName(pc),a1
	moveq	#$00,d0
	CALLEXEC	OldOpenLibrary
	move.l	d0,_GfxBase
	lea	CiabName(pc),a1
	moveq	#$00,d0
	CALLEXEC	OpenResource
	move.l	d0,_CiabBase
	rts

AllocateMemory
	move.l	#TimerBServerEnd-TimerBServer,d0
	move.l	#$00010002,d1
	CALLEXEC	AllocMem
	move.l	d0,IntServerMem
	move.l	#22,d0
	move.l	#$00010002,d1
	CALLEXEC	AllocMem
	move.l	d0,IntStructMem
	move.l	#40,d0
	move.l	#$00010002,d1
	CALLEXEC	AllocMem
	move.l	d0,IntNameMem
	rts

CopyData
	lea	TimerBServer(pc),a0
	move.l	IntServerMem(pc),a1
	lea	TimerBServerEnd(pc),a2
.1
	move.w	(a0)+,(a1)+
	cmpa.l	a0,a2
	bne.s	.1
	lea	IntName(pc),a0
	move.l	IntNameMem(pc),a1
	lea	IntNameEnd(pc),a2
.2
	move.b	(a0)+,(a1)+
	cmpa.l	a0,a2
	bne.s	.2
	rts

InitIntStruct
	move.l	IntStructMem(pc),a0
	clr.l	(a0)+
	clr.l	(a0)+
	move.b	#$02,(a0)+
	move.b	#$00,(a0)+
	move.l	IntNameMem(pc),(a0)+
	clr.l	(a0)+
	move.l	IntServerMem(pc),(a0)+
	rts

AddInterrupt
	move.l	IntStructMem(pc),a1
	moveq	#$01,d0
	CALLCIAB	AddICRVector
	rts

TellSystem
	move.l	(4).W,a0
	move.b	#50,VBlankFrequency(a0)
	move.b	#50,PowerSupplyFrequency(a0)
	move.l	_GfxBase,a0
	move.w	#$0004,gb_DisplayFlags(a0)
	move.w	#$0137,gb_MaxDisplayRow(a0)
	move.w	#$0100,gb_NormalDisplayRows(a0)
	rts

TimerBServer
	movem.l	d0/d1/a0/a1,-(a7)
	and.b	#$f6,$bfdf00
	lea	$6(a0),a0		;$DFF006
	lea	$2c-6(a0),a1		;$DFF02c
	move.w	Event(pc),d0
	bmi	.PAL
	move.w	-4(a0),-(a7)
	move.w	#$0200,d1		;Amount of Y,X steps to skip!
	move.l	-2(a0),-(a7)
.1
	move.l	-2(a0),d0
	cmp.w	#$0480,d0
	bhi.s	.1
	btst	#16,d0
	beq.s	.1
	move.w	#$01e0,$96-6(a0)	;Turn off all DMA except disk
.2
	cmp.w	#$04ff,(a0)		;Wait for the last NTSC line!
	bls.s	.2
	sub.w	(a0),d1
	lsr.w	#2,d0
	add.w	(a0),d1			;Get in syncronization!
	add.w	(a0),d1
	lsr.w	#1,d0
	move.w	d1,(a1)			;Do the magic!
	move.w	-2(a0),d0
	and.w	#$8001,d0
	move.w	d0,-2(a1)
	move.l	(a7)+,d0
	or.w	#$8000,(a7)
	move.w	(a7)+,$96-6(a0)		;Turn on the DMA again
	lea	TimerBCount1(pc),a1
	sub.l	#$00008000,d0
	and.l	#$0001ff00,d0
	cmp.l	#$00008200,d0
	beq.s	.4
	bgt.s	.3
	addq.w	#$8,(a1)
	bra.s	.4
.3
	subq.w	#$8,(a1)
.4
	lea	Event(pc),a0
	st	(a0)
	lea	TimerBCount2(pc),a1
	move.b	(a1),$bfd700
	move.b	1(a1),$bfd600
	or.b	#$11,$bfdf00
	movem.l	(a7)+,d0/d1/a0/a1
	rts
.PAL
	move.w	-4(a0),-(a7)
	move.w	#-$3200,d1		;Amount of Y,X steps to skip!
	move.w	(a0),-(a7)
.P1
	move.l	-2(a0),d0
	cmp.w	#$3680,d0
	bhi.s	.P1
	btst	#16,d0
	beq.s	.P1
	move.w	#$01e0,$96-6(a0)	;Turn off all DMA except disk
.P2
	cmp.w	#$36ff,(a0)		;Wait for the last NTSC line!
	bls.s	.P2
	sub.w	(a0),d1
	lsr.w	#2,d0
	add.w	(a0),d1			;Get in syncronization!
	add.w	(a0),d1
	lsr.w	#1,d0
	move.w	d1,(a1)			;Do the magic!
	move.w	-2(a0),d0
	and.w	#$8001,d0
	move.w	d0,-2(a1)
	move.w	(a7)+,d0
	or.w	#$8000,(a7)
	move.w	(a7)+,$96-6(a0)		;Turn on the DMA again
	lea	TimerBCount2(pc),a1
	cmp.w	#$3400,d0
	beq.s	.P4
	bgt.s	.P3
	addq.w	#$8,(a1)
	bra.s	.P4
.P3
	subq.w	#$8,(a1)
.P4
	lea	Event(pc),a0
	clr.w	(a0)
	lea	TimerBCount1(pc),a1
	move.b	(a1),$bfd700
	move.b	1(a1),$bfd600
	or.b	#$11,$bfdf00
	movem.l	(a7)+,d0/d1/a0/a1
	rts
Event
	dc.w	0
TimerBCount1
	dc.w	11462
TimerBCount2
	dc.w	1000
TimerBServerEnd:


_GfxBase:
	dc.l	0
_CiabBase:
	dc.l	0
IntServerMem:
	dc.l	0
IntStructMem:
	dc.l	0
IntNameMem:
	dc.l	0
IntName:
	dc.b	"FakePAL-CiabTimerB",0
IntNameEnd:

GfxName:
	GRAFNAME
CiabName:
	CIABNAME

