	Section	MainProg,Code
Main:
	move.l	a0,a2
	move.l	d0,d2
	bsr	OpenLibraries
	move.l	a2,a0
	move.l	d2,d0
	move.l	Dir1Name,a1
	bsr	ReadDirName
	move.l	Dir2Name,a1
	bsr	ReadDirName
	move.l	Dir1Name,d1
	bsr	ReadFile
	bsr	MakeToneInfo
	move.l	Dir2Name,d1
	move.l	d1,a1
	tst.b	(a1)
	beq	Main1
	bsr	ReadFile
	bsr	MakeFuncInfo
Main1:
	bsr	InitSound
	bsr	StartIRQ
	bsr	CallLoop
	bsr	StopIRQ
	bsr	CloseLibraries
	moveq	#$00,d0
	rts

StartIRQ:
	move.w	#$4000,$dff09a
	move.l	$6c.w,OldL3IRQ
	move.l	$78.w,OldL6IRQ
	move.l	#L3IRQ,$6c.w
	move.l	#L6IRQ,$78.w
	move.w	#$a000,$dff09a
	move.w	#$c000,$dff09a
	rts

StopIRQ:
	move.w	#$4000,$dff09a
	move.l	OldL3IRQ,$6c.w
	move.l	OldL6IRQ,$78.w
	move.w	#$000f,$dff096
	move.w	#$c000,$dff09a
	rts

L6IRQ:
	move.l	a0,-(a7)
	lea	IRQdata,a0
IRQ0:
	tst.w	8(a0)
	beq	IRQ1
	move.w	(a0),$dff0a6
	move.w	4(a0),$dff0b6
	move.w	6(a0),$dff0c6
	move.w	2(a0),$dff0d6
	tst.w	(a0)
	beq	IRQ0a
	move.w	#$0040,$dff0a8
IRQ0a:
	tst.w	2(a0)
	beq	IRQ0b
	move.w	#$0040,$dff0d8
IRQ0b:
	tst.w	4(a0)
	beq	IRQ0c
	move.w	#$0040,$dff0b8
IRQ0c:
	tst.w	6(a0)
	beq	IRQ1a
	move.w	#$0040,$dff0c8

IRQ1a:
	move.w	#$800f,$dff096
	subq.w	#1,8(a0)
	bra	IRQexit
IRQ1:
	move.w	#$000f,$dff096
	move.l	Sample,a0
	move.l	a0,$dff0a0
	move.l	a0,$dff0b0
	move.l	a0,$dff0c0
	move.l	a0,$dff0d0
	move.w	#$0000,$dff0a8
	move.w	#$0000,$dff0b8
	move.w	#$0000,$dff0c8
	move.w	#$0000,$dff0d8
	lea	IRQdata,a0
	tst.w	10(a0)
	beq	IRQ2
	subq.w	#1,10(a0)
	bra	IRQexit
IRQ2:
	move.l	12(a0),(a0)
	move.l	16(a0),4(a0)
	move.l	20(a0),8(a0)
	clr.l	12(a0)
	clr.l	16(a0)
	clr.l	20(a0)
	tst.w	8(a0)
	bne	IRQ0
IRQexit:
	tst.b	$bfdd00
	lea	RasterCounter(pc),a0
	add.w	#$001f,(a0)
	or.b	#$80,$bfdf00
	move.b	(a0),$bfd900
	move.b	1(a0),$bfd800
	move.w	#$2000,$dff09c
	move.l	(a7)+,a0
	rte

L3IRQ:
	move.l	a0,-(a7)
	lea	RasterCounter(pc),a0
	move.w	#$0018,(a0)
	lea	$bfd000,a0
	and.b	#$7f,$f00(a0)
	move.b	#$00,$a00(a0)
	move.b	#$00,$900(a0)
	move.b	$dff006,$800(a0)
	or.b	#$80,$f00(a0)
	move.b	#$00,$a00(a0)
	move.b	#$00,$900(a0)
	move.b	#$18,$800(a0)
	move.b	#$84,$d00(a0)
	and.b	#$7f,$f00(a0)
	move.l	(a7)+,a0
	move.l	OldL3IRQ,-(a7)
	rts

CallLoop:
	movem.l	d1-d3/a0/a6,-(a7)
CallLoop1:
	bsr	ReadKey
	cmp.b	#$fb,d0
	beq	CallLoop9		;See Pars
	cmp.b	#$fc,d0
	beq	CallLoop8		;Change
	cmp.b	#$fd,d0
	beq	CallLoop7		;Pause
	cmp.b	#$fe,d0
	beq	CallLoop3		;Program
	cmp.b	#$ff,d0
	beq	CallLoop2		;Exit
	cmp.b	#$7f,d0
	bhi	CallLoop4
	bsr	PlayTone
	bra	CallLoop1
CallLoop2:
	movem.l	(a7)+,d1-d3/a0/a6
	rts
CallLoop3:
	bsr	ReadKey
	cmp.b	#$89,d0
	bhi	CallLoop3
	cmp.b	#$7f,d0
	bls	CallLoop3
	move.l	StringBuff,a0
	and.w	#$000f,d0
	mulu	#100,d0
	add.l	d0,a0
	move.l	a0,d2
	move.l	Input,d1
	move.l	#100,d3
	move.l	DosBase,a6
	jsr	-42(a6)
	bra	CallLoop1
CallLoop4:
	cmp.b	#$89,d0
	bhi	CallLoop1
	move.l	StringBuff,a0
	and.w	#$000f,d0
	mulu	#100,d0
	add.l	d0,a0
CallLoop5:
	move.b	(a0)+,d0
	beq	CallLoop1
	cmp.b	#$0a,d0
	beq	CallLoop1
	cmp.b	#$0d,d0
	beq	CallLoop1
	btst	#6,d0
	beq	CallLoop6
	and.b	#$5f,d0
CallLoop6:
	bsr	PlayTone
	bra	CallLoop5
CallLoop7:
	bsr	ReadKey
	cmp.b	#$fc,d0
	bne	CallLoop1
	lea	PauseOn(pc),a0
	move.l	a0,d0
	bsr	WriteString
	bsr	StopIRQ

	move.l	Input,d1
	move.l	FileBuff,d2
	move.l	#100,d3
	move.l	DosBase,a6
	jsr	-42(a6)

CallLoop7a:
	bsr	ReadKey
	cmp.b	#$fd,d0
	bne	CallLoop7a
	bsr	ReadKey
	cmp.b	#$fc,d0
	bne	CallLoop7a
	lea	PauseOff(pc),a0
	move.l	a0,d0
	bsr	WriteString
	bsr	StartIRQ
	bra	CallLoop1
CallLoop8:
	bsr	ReadKey
	move.l	ToneInfo,a0
	and.w	#$00ff,d0
	ext.l	d0
	mulu	#$0018,d0
	add.l	d0,a0
	bsr	ReadKey
	cmp.b	#$31,d0
	beq	CallLoop8a
	cmp.b	#$32,d0
	beq	CallLoop8b
	cmp.b	#$33,d0
	beq	CallLoop8c
	cmp.b	#$34,d0
	beq	CallLoop8d
	cmp.b	#$35,d0
	beq	CallLoop8e
	cmp.b	#$36,d0
	beq	CallLoop8f
	cmp.b	#$37,d0
	beq	CallLoop8g
	cmp.b	#$38,d0
	beq	CallLoop8h
	bra	CallLoop1
CallLoop8a:
	add.w	#$0005,8(a0)
	bra	CallLoop1
CallLoop8b:
	add.w	#$0005,10(a0)
	bra	CallLoop1
CallLoop8c:
	add.w	#$0005,20(a0)
	bra	CallLoop1
CallLoop8d:
	add.w	#$0005,22(a0)
	bra	CallLoop1
CallLoop8e:
	sub.w	#$0005,8(a0)
	bra	CallLoop1
CallLoop8f:
	sub.w	#$0005,10(a0)
	bra	CallLoop1
CallLoop8g:
	sub.w	#$0005,20(a0)
	bra	CallLoop1
CallLoop8h:
	sub.w	#$0005,22(a0)
	bra	CallLoop1
CallLoop9:
	bsr	ReadKey
	cmp.b	#$7f,d0
	bhi	CallLoop10
	move.b	d0,d1
	bsr	WriteChar
	moveq	#$00,d0
	move.b	d1,d0
	mulu	#$0018,d0
	move.l	ToneInfo,a0
	add.l	d0,a0
	moveq	#$01,d2
	move.l	#10000,d1
CallLoop9a:
	moveq	#",",d0
	bsr	WriteChar
	moveq	#$00,d0
	move.w	(a0)+,d0
	bsr	ConvertFreq
	bsr	WriteDecNumberII
	moveq	#",",d0
	bsr	WriteChar
	moveq	#$00,d0
	move.w	(a0)+,d0
	bsr	ConvertFreq
	bsr	WriteDecNumberII

	moveq	#",",d0
	bsr	WriteChar
	moveq	#$00,d0
	move.w	(a0)+,d0
	bsr	ConvertFreq
	bsr	WriteDecNumberII
	moveq	#",",d0
	bsr	WriteChar
	moveq	#$00,d0
	move.w	(a0)+,d0
	bsr	ConvertFreq
	bsr	WriteDecNumberII

	moveq	#",",d0
	bsr	WriteChar
	moveq	#$00,d0
	move.w	(a0)+,d0
	add.w	d0,d0
	bsr	WriteDecNumberII
	moveq	#",",d0
	bsr	WriteChar
	moveq	#$00,d0
	move.w	(a0)+,d0
	add.w	d0,d0
	bsr	WriteDecNumberII
	dbf	d2,CallLoop9a
	moveq	#$0a,d0
	bsr	WriteChar
	bra	CallLoop1
CallLoop10:
	cmp.b	#$89,d0
	bhi	CallLoop1
	move.l	StringBuff,a0
	and.w	#$000f,d0
	mulu	#100,d0
	add.l	d0,a0
CallLoop10a:
	move.b	(a0)+,d0
	beq	CallLoop10c
	cmp.b	#$0a,d0
	beq	CallLoop10c
	cmp.b	#$0d,d0
	beq	CallLoop10c
	btst	#6,d0
	beq	CallLoop10b
	and.b	#$5f,d0
CallLoop10b:
	bsr	WriteChar
	bra	CallLoop10a
CallLoop10c:
	moveq	#$0a,d0
	bsr	WriteChar
	bra	CallLoop1

PlayTone:
	movem.l	d0/a0-a1,-(a7)
	bsr	InitSound
	move.l	ToneInfo,a0
	and.w	#$00ff,d0
	ext.l	d0
	mulu	#$0018,d0
	add.l	d0,a0
	lea	IRQdata,a1
	move.w	#$4000,$dff09a
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.w	#$c000,$dff09a
	lea	IRQdata,a0
PlayTone1:
	tst.l	8(a0)
	bne	PlayTone1
	tst.l	20(a0)
	bne	PlayTone1
	movem.l	(a7)+,d0/a0-a1
	rts

ReadKey:
	movem.l	d1-d2/a0,-(a7)
ReadKey1:
	move.b	$bfec01,d0
	not.b	d0
	lsr.b	#1,d0
	bcs	ReadKey1
	lea	KeyboardData,a0
ReadKey2:
	move.b	(a0)+,d1
	move.b	(a0)+,d2
	cmp.b	d1,d0
	beq	ReadKey3
	cmp.b	#$ff,d1
	beq	ReadKey1
	bra	ReadKey2
ReadKey3:
	move.b	$bfec01,d0
	not.b	d0
	lsr.b	#1,d0
	bcc	ReadKey3
	moveq	#$00,d0
	move.b	d2,d0
	movem.l	(a7)+,d1-d2/a0
	rts

KeyboardData:
	dc.b	$01,"1",$02,"2",$03,"3",$04,"4"
	dc.b	$04,"4",$05,"5",$06,"6",$07,"7"
	dc.b	$08,"8",$09,"9",$0a,"0"
	dc.b	$20,"A",$35,"B",$33,"C",$22,"D"
	dc.b	$12,"E",$23,"F",$24,"G",$25,"H"
	dc.b	$17,"I",$26,"J",$27,"K",$28,"L"
	dc.b	$37,"M",$36,"N",$18,"O",$19,"P"
	dc.b	$10,"Q",$13,"R",$21,"S",$14,"T"
	dc.b	$16,"U",$34,"V",$11,"W",$32,"X"
	dc.b	$15,"Y",$31,"Z"
	dc.b	$0b,"-",$0c,"=",$0d,"\"
	dc.b	$1a,"[",$1b,"]",$29,";",$2a,"'"
	dc.b	$38,",",$39,".",$3a,"/",$4a,"-"
	dc.b	$3d,"7",$3e,"8",$3f,"9",$2d,"4"
	dc.b	$2e,"5",$2f,"6",$1d,"1",$1e,"2"
	dc.b	$1f,"3",$0f,"0",$3c,"."
	dc.b	$50,$80,$51,$81,$52,$82,$53,$83
	dc.b	$54,$84,$55,$85,$56,$86,$57,$87
	dc.b	$58,$88,$59,$89
	dc.b	$67,$fb				;Right AMIGA
	dc.b	$66,$fc				;Left AMIGA
	dc.b	$63,$fd				;CTRL
	dc.b	$5f,$fe				;HELP
	dc.b	$43,$0a,$44,$0a			;ENTER,RETURN
	dc.b	$45,$ff				;ESC
	dc.b	$ff,$ff

InitSound:
	move.l	a0,-(a7)
	move.l	Sample,a0
	move.w	#$000f,$dff096
	move.l	a0,$dff0a0
	move.l	a0,$dff0b0
	move.l	a0,$dff0c0
	move.l	a0,$dff0d0

	move.w	#$0004,$dff0a4
	move.w	#$0004,$dff0b4
	move.w	#$0004,$dff0c4
	move.w	#$0004,$dff0d4

	move.w	#$0100,$dff0a6
	move.w	#$0100,$dff0b6
	move.w	#$0100,$dff0c6
	move.w	#$0100,$dff0d6

	move.w	#$0000,$dff0a8
	move.w	#$0000,$dff0b8
	move.w	#$0000,$dff0c8
	move.w	#$0000,$dff0d8
	move.l	(a7)+,a0
	rts

ReadFile:
	movem.l	d0-d3/a0/a6,-(a7)
	move.l	DosBase,a6
	move.l	#1005,d2
	jsr	-30(a6)
	move.l	d0,d1
	move.l	d1,FileStruct
	move.l	FileBuff,d2
	move.l	#16000,d3
	jsr	-42(a6)
	move.l	FileBuff,a0
	add.l	d0,a0
	clr.b	(a0)
	clr.b	1(a0)
	move.l	FileStruct,d1
	jsr	-36(a6)
	movem.l	(a7)+,d0-d3/a0/a6
	rts

MakeToneInfo:
	movem.l	d0-d1/a0-a2,-(a7)
	move.l	ToneInfo,a1
	move.l	FileBuff,a0
MakeToneInfo1:
	moveq	#$00,d0
	move.b	(a0)+,d0
	beq	MakeToneInfo3
	btst	#6,d0
	beq	MakeToneInfo2
	and.w	#$005f,d0
MakeToneInfo2:
	mulu	#$0018,d0
	move.l	a1,a2
	add.l	d0,a2
	move.b	(a0)+,d0
	beq	MakeToneInfo3

	bsr	MakeToneInfoDec
	bsr	ConvertFreq
	move.w	d0,(a2)
	bsr	MakeToneInfoDec
	bsr	ConvertFreq
	move.w	d0,2(a2)

	bsr	MakeToneInfoDec
	bsr	ConvertFreq
	move.w	d0,4(a2)
	bsr	MakeToneInfoDec
	bsr	ConvertFreq
	move.w	d0,6(a2)

	bsr	MakeToneInfoDec
	bsr	ConvertDur
	move.w	d0,8(a2)
	bsr	MakeToneInfoDec
	bsr	ConvertDur
	move.w	d0,10(a2)

	bsr	MakeToneInfoDec
	bsr	ConvertFreq
	move.w	d0,12(a2)
	bsr	MakeToneInfoDec
	bsr	ConvertFreq
	move.w	d0,14(a2)

	bsr	MakeToneInfoDec
	bsr	ConvertFreq
	move.w	d0,16(a2)
	bsr	MakeToneInfoDec
	bsr	ConvertFreq
	move.w	d0,18(a2)

	bsr	MakeToneInfoDec
	bsr	ConvertDur
	move.w	d0,20(a2)
	bsr	MakeToneInfoDec
	bsr	ConvertDur
	move.w	d0,22(a2)

	bra	MakeToneInfo1
MakeToneInfo3:
	movem.l	(a7)+,d0-d1/a0-a2
	rts

MakeToneInfoDec:
	move.l	d1,-(a7)
	moveq	#$00,d1
	tst.b	(a0)
	beq	MakeToneInfoDec2
MakeToneInfoDec1:
	move.b	(a0)+,d0	
	beq	MakeToneInfoDec2
	cmp.b	#",",d0
	beq	MakeToneInfoDec2
	cmp.b	#$0a,d0
	beq	MakeToneInfoDec2
	mulu	#10,d1
	and.w	#$0f,d0
	add.w	d0,d1
	bra	MakeToneInfoDec1
MakeToneInfoDec2:
	move.l	d1,d0
	move.l	(a7)+,d1
	rts

MakeFuncInfo:
	movem.l	d0-d1/a0-a2,-(a7)
	move.l	StringBuff,a1
	move.l	FileBuff,a0
MakeFuncInfo1:
	tst.b	(a0)
	beq	MakeFuncInfo3
	bsr	MakeToneInfoDec
	tst.b	(a0)
	beq	MakeFuncInfo3
	sub.w	#1,d0
	and.w	#$000f,d0
	mulu	#100,d0
	move.l	a1,a2
	add.l	d0,a2
MakeFuncInfo2:
	move.b	(a0)+,d1
	move.b	d1,(a2)+
	cmp.b	#$0a,d1
	beq	MakeFuncInfo1
	cmp.b	#$00,d1
	bne	MakeFuncInfo2
	move.b	#$0a,-1(a2)
MakeFuncInfo3:
	movem.l	(a7)+,d0-d1/a0-a2
	rts

ConvertFreq:
	move.l	d1,-(a7)
	tst.w	d0
	beq	ConvertFreq1
	move.l	#443362,d1
	divu	d0,d1
	move.w	d1,d0
ConvertFreq1:
	move.l	(a7)+,d1
	rts

ConvertDur:
	add.w	#1,d0
	lsr.l	#1,d0
	rts

ReadDirName:		;A0=Commandline,D0=NrChars,A1=DirName
	movem.l	d1/d2/a1,-(a7)
	moveq	#$20,d2
ReadDirName1:
	subq.l	#1,d0
	bmi	ReadDirName3
	move.b	(a0)+,d1
	cmp.b	#$20,d1
	beq	ReadDirName1
	cmp.b	#$0a,d1
	beq	ReadDirName3
	cmp.b	#$22,d1
	bne	ReadDirName2
	move.b	d1,d2
	subq.l	#1,d0
	bmi	ReadDirName3
	move.b	(a0)+,d1
ReadDirName2:
	move.b	d1,(a1)+
	subq.l	#1,d0
	bmi	ReadDirName3
	move.b	(a0)+,d1
	cmp.b	#$0a,d1
	beq	ReadDirName3
	cmp.b	d2,d1
	bne	ReadDirName2
ReadDirName3:
	clr.b	(a1)
	movem.l	(a7)+,d1/d2/a1
	rts

OpenLibraries:
	movem.l	a1/a6,-(a7)
	move.l	$0004.w,a6
	lea	DOS_Name(pc),a1
	jsr	-408(a6)		;OldOpenLibrary(libName)(A1)
	move.l	d0,DosBase
	lea	INTUITION_Name(pc),a1
	jsr	-408(a6)		;OldOpenLibrary(libName)(A1)
	move.l	d0,IntuitionBase
	move.l	DosBase,a6
	jsr	-60(a6)			;Output()
	move.l	d0,Output
	jsr	-54(a6)
	move.l	d0,Input		;Input()
	movem.l	(a7)+,a1/a6
	rts

CloseLibraries:
	movem.l	a1/a6,-(a7)
	move.l	$0004.w,a6
	move.l	DosBase,a1
	jsr	-414(a6)		;CloseLibrary(library)(A1)
	move.l	IntuitionBase,a1
	jsr	-414(a6)		;CloseLibrary(library)(A1)
	movem.l	(a7)+,a1/a6
	rts

WriteChar:
	movem.l	d1-d3/a0-a1,-(a7)
	move.l	Textbuff,a0
	move.w	CursorX,d3
	move.b	d0,0(a0,d3.w)
	addq.w	#1,CursorX
	cmp.b	#$0a,d0
	bne	WriteChar2
	clr.w	CursorX
	move.l	DosBase,a6
	move.l	Output,d1
	move.l	a0,d2
	addq.w	#1,d3
	jsr	-48(a6)
	move.l	Textbuff,a0
	moveq	#$20,d0
	moveq	#$4f,d1
WriteChar1:
	move.b	d0,(a0)+
	dbf	d1,WriteChar1
WriteChar2:
	movem.l	(a7)+,d1-d3/a0-a1
	rts

WriteString:
	move.l	a1,-(a7)
	move.l	d0,a1
WriteString1:
	move.b	(a1)+,d0
	beq	WriteStringEnd
	bsr	WriteChar
	bra	WriteString1
WriteStringEnd:
	move.l	(a7)+,a1
	rts

WriteNumber:
	and.b	#$0f,d0
	cmp.b	#$0a,d0
	bcs	WriteNumber1
	addq.b	#7,d0
WriteNumber1:
	add.b	#$30,d0
	bsr	WriteChar
	rts

WriteDecNumber:			;d0=number,d1=highestten(1000,100...)
	movem.l	d1-d5,-(a7)
	moveq	#$20,d5		;Spaces before number
WriteDecNumberII0:
	move.l	d1,d3
	moveq	#$00,d4
WriteDecNumber0:
	moveq	#-1,d2
	add.l	d3,d0
WriteDecNumber1:
	sub.l	d3,d0
	addq.b	#1,d2
	cmp.l	d3,d0
	beq	WriteDecNumber1
	bhi	WriteDecNumber1
	move.l	d0,d1
	move.b	d2,d0
	tst.b	d4
	bne	WriteDecNumber2
	tst.b	d2
	beq	WriteDecNumber3
WriteDecNumber2:
	moveq	#$01,d4
	bsr	WriteNumber
	bra	WriteDecNumber4
WriteDecNumber3:
	move.b	d5,d0
	beq	WriteDecNumber4
	bsr	WriteChar
WriteDecNumber4:
	move.l	d1,d0
	move.l	d3,d1
	clr.w	d3
	swap	d3
	divu	#$000a,d3
	swap	d3
	swap	d1
	move.w	d3,d1
	swap	d1
	divu	#$000a,d1
	move.w	d1,d3
	cmp.l	#$00000001,d1
	bne	WriteDecNumber0
	bsr	WriteNumber
	movem.l	(a7)+,d1-d5
	rts

WriteDecNumberII:		;d0=number,d1=highestten(1000,100...)
	movem.l	d1-d5,-(a7)
	moveq	#$00,d5			;No Spaces
	bra	WriteDecNumberII0

PauseOn:
	dc.b	"Pause On",10,0
PauseOff:
	dc.b	"Pause Off",10,0

DOS_Name:
	dc.b	"dos.library",0
INTUITION_Name:
	dc.b	"intuition.library",0
	even

CursorX:
	dc.w	0
RasterCounter:
	dc.w	0
OldL3IRQ:
	dc.l	0
OldL6IRQ:
	dc.l	0
DosBase:
	dc.l	0
IntuitionBase:
	dc.l	0
Input:
	dc.l	0
Output:
	dc.l	0
FileStruct:
	dc.l	0
ToneInfo:
	dc.l	ToneMem
Dir1Name:
	dc.l	Dir1NameMem	;$0050 bytes
Dir2Name:
	dc.l	Dir2NameMem	;$0050 bytes
StringBuff:
	dc.l	StringMem
Textbuff:
	dc.l	TextBuffMem	;$0050 bytes
FileBuff:
	dc.l	InputMem
Sample:
	dc.l	Waveform
IRQdata:
	dc.l	0,0,0,0,0,0

	Section	Sinusdata,Data_C
Waveform:
	dc.b	0,90,127,90,0,-90,-127,-90

	Section	Strings,BSS
StringMem:
	ds.l	1000/4

	Section	Tones,BSS
*	freq1,freq2,freq3,freq4,length,length,freq1,freq2,freq3,freq4,length,length
ToneMem:
	ds.w	256*12
	Section	Filename,BSS
Dir1NameMem:
	ds.l	$50/4
Dir2NameMem:
	ds.l	$50/4

	Section	Textbuffer,BSS
TextBuffMem:
	ds.l	$50/4

	Section	Inputdata,BSS
InputMem:
	ds.l	16000/4

